<template>
  <div class="style__amortization">
    <!-- Cuerpo -->
    <div style="margin: 0 4rem"  class="padding-top">
      <el-header height="100px" style="margin: 0 2.75rem;">
        <el-row>
          <!-- Subtítulo -->
          <el-col :span="24" style="position:absolute; top:0">
            <img src="@/assets/images/esquema-amortizacion.svg" alt="amortizacion" width="100%">
          </el-col>
        </el-row>
        <!-- Botón nuevo -->
        <el-row style="padding-top: 3.5rem" type="flex" justify="end">
          <el-col :span="14" class="text-end">
            <el-button type="primary"
              @click="amortButton"
              tag="button">NUEVO ESQUEMA</el-button>
          </el-col>
        </el-row>
      </el-header>
      <el-main style="padding-top: 10rem; margin:0 2.5rem; display: flex; justify-content: center; min-height: 300px">
        <el-row v-loading="loading" :element-loading-text="loadingText">
          <el-col :span="21" v-for="(type, index) in amortization" :key="index" :offset="3">
            <el-card v-if="type.show" :body-style="{ padding: '1px 1px 0 21px' }" style="margin-bottom:3rem; width:80%; min-height: 300px" >
              <div style="padding: 50px 14px 30px 35px;">
                <el-row :span="12">
                  <el-col :span="20">
                    <h3 class="text-orange" style="margin-bottom:1.5rem">ESQUEMA  {{ type.schemaName.toUpperCase() || '---'}}</h3>
                  </el-col>
                  <el-col :span="4">
                    <img src="@/assets/images/edit.svg" alt="edit" width="33" style="margin-right:1.5rem"
                    @click="editAmort(index)">
                    <img src="@/assets/images/basura-2.svg" alt="basura" width="33"
                     @click="deleteAmort(index)">
                  </el-col>
                </el-row>
                <el-row :span="12">
                  <el-col :span="24"  style="margin-top: 2.5rem">
                    <el-col :span="12" style="border-right: 1.5px solid rgb(130,130,130)">
                      <el-col>
                        <p class="fonts-bold-general" style="margin:0 5rem 0.5rem 0; padding:8px 0px">Tipo de Contrato:</p>
                        <span v-for= "(contract, h) in type.contractType" v-if="h===type.contractType.length-1" :key="h"> {{contract}}</span>
                        <span v-else> {{contract + ","}}</span>
                      </el-col>
                      <el-col style="margin-top: 10px">
                        <p class="fonts-bold-general" style="margin: 0 5rem 0.5rem 0; padding:7px 0px">Tipo de Contenido: </p>
                        <span v-for= "(item, j) in type.materialTypes" v-if="j===type.materialTypes.length-1" :key="j"> {{item}}</span>
                        <span  v-else > {{item + ","}}</span>
                      </el-col>
                    </el-col>
                    
                    <el-col :span="9" :offset="3"> 
                      <!-- <p class="fonts-bold-general" style="margin: 0 5rem 0.5rem 0; padding:8px 0px">N° de Amortizaciones: <span class="text-orange">{{' '+ type.amortizationPercentage}}</span></p>
                      <p v-for= "porcentaje in type.arrayOfPercentage" :key="porcentaje.indexPercentage">
                      {{porcentaje.indexPercentage}}° Pasada de {{porcentaje.amortizationP}}%</p> -->
                      <p class="fonts-bold-general" style="margin: 0 5rem 0.5rem 0; padding:8px 0px">N° de Amortizaciones: <span class="text-orange">{{' '+ type.amortizationPercentage}}</span></p>
                      <p v-for="(description, i) in transformValue(type)" :key="i">
                      {{description}}</p>
                    </el-col>
                  </el-col>
                </el-row>
              </div>
            <!-- modal eliminar-->

              <AppModal :show-dialog.sync="modalCancel"   v-if="modalCancel" nameClass="dialog-red"  :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80px"  textBold="¡Un momento!" 
                :parrafo="'¿Seguro de que quieres eliminar el esquema de Amortización ' +  nameAmort "
                classBtn1="border-red" typeBtn1="danger" btn1="ELIMINAR" btn2="CANCELAR"  @btnEvent="deleteButton" v-on:eventBtn="modalCancel = false">
             </AppModal>

            </el-card>
          </el-col>
        </el-row>
      </el-main>
    </div>
  </div>
</template>

<script>

import NewAmortizationVue from "./NewAmortization.vue"
import AppModal from '@/components/AppModal.vue'
import {HTTP} from '@/main.js'

export default {
  components: {
    AppModal
  },
  data() {
    return {
      theAmortization:'',
      modalCancel:false,
      newIndex:0,
      nameAmort:'',
      idAmort: '',
      loading: true,
      loadingText: 'Cargando Amortizaciones...'
    };
  },
  computed: {
    amortization () {
      let dataTables = this.$store.state.amortization
      this.theAmortization = dataTables
      return dataTables
    }
  },
  created() {
    this.getSchemaAmort()
    this.verifyContent()
  },
  methods: {
    transformValue(array) {
      let elementBase = array.description
      let arrayIndexPercentage = elementBase.map((e) => Number(e.slice(0, 1)))
      let filterDiferentOne = arrayIndexPercentage.filter((e) => e !== 1)
      
      let response
      if (filterDiferentOne.length > 0) {
        response = array.description
      } else {
        let value = array.arrayOfPercentage.map((e)=> e.amortizationP)
        let result = value.map((e) => `1 Pasada de ${e}%`)
        response = result
      }
      console.log({filterDiferentOne, response, array})
      return response
    },
    getSchemaAmort () {
      let dataType = "amortization"
      this.$store.dispatch("getData", dataType)
    },
    amortButton () {
      /*Guarda en el localStorage para luego comparar el material nuevo con los que ya estan creados su tipo de material, y hacer la priorizacion correspondiente*/
      this.$localStorage.set("tableAmort", JSON.stringify(this.theAmortization))
      this.$router.push({ name: "newAmortization" })
    },
    editAmort (index) {
      /*Guarda en el localStorage la data de todos los esquemas para hacer la comparación de los tipo de material(series, largometraje, etc) y para luego priorizar*/
      this.$localStorage.set("tableAmort", JSON.stringify(this.theAmortization))
      // boton editar
      let targetId = this.theAmortization[index]._id
      this.$localStorage.set("amortizationId", JSON.stringify(targetId))
      this.$router.push({ name: "editAmortization" })
      // this.$router.push({ name: "editAmortization" });
    },
    deleteAmort (index) {
      this.modalCancel=true
      this.newIndex=index
      let getSchemaN = this.theAmortization
      this.nameAmort=getSchemaN[index].schemaName
      this.idAmort = getSchemaN[index]._id
    },
    // boton eliminar del modal
    deleteButton () {
      HTTP.delete(`amortization/` + this.idAmort)
        .then(res => {
          this.modalCancel = false
          this.getSchemaAmort()
        })
        .catch(err => console.log(err))
    },
    verifyContent() {
      if(this.amortization.length > 0) {
        this.loading = false
      } else {
        this.loading = true
      }
    }
  },
  watch: {
    amortization(val) {
      this.verifyContent()
    }
  }
}
</script>

<style>
  .style__amortization .el-card.is-always-shadow {
    box-shadow: 2px 3px 0px rgba(0, 0, 0, 0.2) !important;
  }
  .style__amortization .el-card {
    border-radius: 0px !important;
    border: 1px solid #b4b4b4 !important;
  }
  .el-loading-parent--relative {
    width: 100%
  }
      
</style>

